using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;

using Microsoft.VisualBasic;
using System;
using System.Diagnostics;
using System.Windows.Forms;
using USBPanicButton;

///  <summary>
/// Project: USB Panic Button
/// 
/// ***********************************************************************
/// Software License Agreement
///
/// Licensor grants any person obtaining a copy of this software ("You") 
/// a worldwide, royalty-free, non-exclusive license, for the duration of 
/// the copyright, free of charge, to store and execute the Software in a 
/// computer system and to incorporate the Software or any portion of it 
/// in computer programs You write.   
/// 
/// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
/// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
/// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
/// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
/// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
/// THE SOFTWARE.
/// ***********************************************************************
/// 
/// Author
/// John Bruin http://www.johnbruin.net
/// 
/// With credits to Jan Axelson for the GenericHid routines and sample code
/// </summary> 

namespace USBPanicButton
{
    internal class FrmMain : System.Windows.Forms.Form
    {
        #region '"Windows Form Designer generated code "'
        public FrmMain()
            : base()
        {

            // This call is required by the Windows Form Designer.
            InitializeComponent();
        }
        // Form overrides dispose to clean up the component list.
        protected override void Dispose(bool Disposing)
        {
            if (Disposing)
            {
                if (!(components == null))
                {
                    components.Dispose();
                }
            }
            base.Dispose(Disposing);
        }

        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components;
        public System.Windows.Forms.ToolTip ToolTip1;
        public System.Windows.Forms.Timer tmrContinuousDataCollect;
        private NotifyIcon notifyIcon1;
        private TextBox txtWav;
        private Button cmdWav;
        private Label label1;
        private Label label2;
        private Button cmdCommand;
        private TextBox txtCommand;
        private CheckBox chkPowerPoint;
        private CheckBox chkEarthQuake;
        private Label label3;
        private Button cmdPicture;
        private TextBox txtPicture;
        private ContextMenuStrip contextMenuStrip1;
        private ToolStripMenuItem Settings;
        private Button cmdPictureClear;
        private Button cmdCommandClear;
        private Button cmdSoundClear;
        private Button cmdTest;
        private ToolStripMenuItem Exit;
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.   

        [System.Diagnostics.DebuggerStepThrough()]
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FrmMain));
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.tmrContinuousDataCollect = new System.Windows.Forms.Timer(this.components);
            this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
            this.contextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.Settings = new System.Windows.Forms.ToolStripMenuItem();
            this.Exit = new System.Windows.Forms.ToolStripMenuItem();
            this.txtWav = new System.Windows.Forms.TextBox();
            this.cmdWav = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.cmdCommand = new System.Windows.Forms.Button();
            this.txtCommand = new System.Windows.Forms.TextBox();
            this.chkPowerPoint = new System.Windows.Forms.CheckBox();
            this.chkEarthQuake = new System.Windows.Forms.CheckBox();
            this.label3 = new System.Windows.Forms.Label();
            this.cmdPicture = new System.Windows.Forms.Button();
            this.txtPicture = new System.Windows.Forms.TextBox();
            this.cmdPictureClear = new System.Windows.Forms.Button();
            this.cmdCommandClear = new System.Windows.Forms.Button();
            this.cmdSoundClear = new System.Windows.Forms.Button();
            this.cmdTest = new System.Windows.Forms.Button();
            this.contextMenuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // tmrContinuousDataCollect
            // 
            this.tmrContinuousDataCollect.Interval = 1;
            this.tmrContinuousDataCollect.Tick += new System.EventHandler(this.tmrContinuousDataCollect_Tick);
            // 
            // notifyIcon1
            // 
            this.notifyIcon1.ContextMenuStrip = this.contextMenuStrip1;
            this.notifyIcon1.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon1.Icon")));
            this.notifyIcon1.Text = "USB Panic Button";
            this.notifyIcon1.DoubleClick += new System.EventHandler(this.notifyIcon1_DoubleClick);
            // 
            // contextMenuStrip1
            // 
            this.contextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.Settings,
            this.Exit});
            this.contextMenuStrip1.Name = "contextMenuStrip1";
            this.contextMenuStrip1.Size = new System.Drawing.Size(117, 48);
            // 
            // Settings
            // 
            this.Settings.Name = "Settings";
            this.Settings.Size = new System.Drawing.Size(116, 22);
            this.Settings.Text = "Settings";
            this.Settings.Click += new System.EventHandler(this.Settings_Click);
            // 
            // Exit
            // 
            this.Exit.Name = "Exit";
            this.Exit.Size = new System.Drawing.Size(116, 22);
            this.Exit.Text = "Exit";
            this.Exit.Click += new System.EventHandler(this.Exit_Click);
            // 
            // txtWav
            // 
            this.txtWav.Location = new System.Drawing.Point(80, 56);
            this.txtWav.Name = "txtWav";
            this.txtWav.Size = new System.Drawing.Size(241, 20);
            this.txtWav.TabIndex = 4;
            // 
            // cmdWav
            // 
            this.cmdWav.Location = new System.Drawing.Point(323, 56);
            this.cmdWav.Name = "cmdWav";
            this.cmdWav.Size = new System.Drawing.Size(24, 20);
            this.cmdWav.TabIndex = 5;
            this.cmdWav.Text = "...";
            this.cmdWav.UseVisualStyleBackColor = true;
            this.cmdWav.Click += new System.EventHandler(this.cmdWav_Click);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(17, 59);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(60, 14);
            this.label1.TabIndex = 3;
            this.label1.Text = "Sound File:";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(20, 87);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(57, 14);
            this.label2.TabIndex = 6;
            this.label2.Text = "Command:";
            // 
            // cmdCommand
            // 
            this.cmdCommand.Location = new System.Drawing.Point(323, 84);
            this.cmdCommand.Name = "cmdCommand";
            this.cmdCommand.Size = new System.Drawing.Size(24, 20);
            this.cmdCommand.TabIndex = 8;
            this.cmdCommand.Text = "...";
            this.cmdCommand.UseVisualStyleBackColor = true;
            this.cmdCommand.Click += new System.EventHandler(this.cmdCommand_Click);
            // 
            // txtCommand
            // 
            this.txtCommand.Location = new System.Drawing.Point(80, 84);
            this.txtCommand.Name = "txtCommand";
            this.txtCommand.Size = new System.Drawing.Size(241, 20);
            this.txtCommand.TabIndex = 7;
            // 
            // chkPowerPoint
            // 
            this.chkPowerPoint.AutoSize = true;
            this.chkPowerPoint.Location = new System.Drawing.Point(80, 111);
            this.chkPowerPoint.Name = "chkPowerPoint";
            this.chkPowerPoint.Size = new System.Drawing.Size(166, 18);
            this.chkPowerPoint.TabIndex = 9;
            this.chkPowerPoint.Text = "PowerPoint next slide control";
            this.chkPowerPoint.UseVisualStyleBackColor = true;
            // 
            // chkEarthQuake
            // 
            this.chkEarthQuake.AutoSize = true;
            this.chkEarthQuake.Checked = true;
            this.chkEarthQuake.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkEarthQuake.Location = new System.Drawing.Point(80, 135);
            this.chkEarthQuake.Name = "chkEarthQuake";
            this.chkEarthQuake.Size = new System.Drawing.Size(80, 18);
            this.chkEarthQuake.TabIndex = 10;
            this.chkEarthQuake.Text = "Earthquake";
            this.chkEarthQuake.UseVisualStyleBackColor = true;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(34, 33);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(43, 14);
            this.label3.TabIndex = 0;
            this.label3.Text = "Picture:";
            // 
            // cmdPicture
            // 
            this.cmdPicture.Location = new System.Drawing.Point(322, 30);
            this.cmdPicture.Name = "cmdPicture";
            this.cmdPicture.Size = new System.Drawing.Size(24, 20);
            this.cmdPicture.TabIndex = 2;
            this.cmdPicture.Text = "...";
            this.cmdPicture.UseVisualStyleBackColor = true;
            this.cmdPicture.Click += new System.EventHandler(this.cmdPicture_Click);
            // 
            // txtPicture
            // 
            this.txtPicture.Location = new System.Drawing.Point(80, 30);
            this.txtPicture.Name = "txtPicture";
            this.txtPicture.Size = new System.Drawing.Size(241, 20);
            this.txtPicture.TabIndex = 1;
            // 
            // cmdPictureClear
            // 
            this.cmdPictureClear.Location = new System.Drawing.Point(350, 30);
            this.cmdPictureClear.Name = "cmdPictureClear";
            this.cmdPictureClear.Size = new System.Drawing.Size(42, 20);
            this.cmdPictureClear.TabIndex = 3;
            this.cmdPictureClear.Text = "Clear";
            this.cmdPictureClear.UseVisualStyleBackColor = true;
            this.cmdPictureClear.Click += new System.EventHandler(this.cmdPictureClear_Click);
            // 
            // cmdCommandClear
            // 
            this.cmdCommandClear.Location = new System.Drawing.Point(350, 84);
            this.cmdCommandClear.Name = "cmdCommandClear";
            this.cmdCommandClear.Size = new System.Drawing.Size(42, 20);
            this.cmdCommandClear.TabIndex = 9;
            this.cmdCommandClear.Text = "Clear";
            this.cmdCommandClear.UseVisualStyleBackColor = true;
            this.cmdCommandClear.Click += new System.EventHandler(this.cmdCommandClear_Click);
            // 
            // cmdSoundClear
            // 
            this.cmdSoundClear.Location = new System.Drawing.Point(350, 56);
            this.cmdSoundClear.Name = "cmdSoundClear";
            this.cmdSoundClear.Size = new System.Drawing.Size(42, 20);
            this.cmdSoundClear.TabIndex = 6;
            this.cmdSoundClear.Text = "Clear";
            this.cmdSoundClear.UseVisualStyleBackColor = true;
            this.cmdSoundClear.Click += new System.EventHandler(this.cmdSoundClear_Click);
            // 
            // cmdTest
            // 
            this.cmdTest.Location = new System.Drawing.Point(323, 147);
            this.cmdTest.Name = "cmdTest";
            this.cmdTest.Size = new System.Drawing.Size(75, 23);
            this.cmdTest.TabIndex = 11;
            this.cmdTest.Text = "Test";
            this.cmdTest.UseVisualStyleBackColor = true;
            this.cmdTest.Click += new System.EventHandler(this.cmdTest_Click);
            // 
            // FrmMain
            // 
            this.CausesValidation = false;
            this.ClientSize = new System.Drawing.Size(423, 182);
            this.Controls.Add(this.cmdTest);
            this.Controls.Add(this.cmdSoundClear);
            this.Controls.Add(this.cmdCommandClear);
            this.Controls.Add(this.cmdPictureClear);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.cmdPicture);
            this.Controls.Add(this.txtPicture);
            this.Controls.Add(this.chkEarthQuake);
            this.Controls.Add(this.chkPowerPoint);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.cmdCommand);
            this.Controls.Add(this.txtCommand);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.cmdWav);
            this.Controls.Add(this.txtWav);
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Location = new System.Drawing.Point(21, 28);
            this.MaximizeBox = false;
            this.Name = "FrmMain";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "USB Panic Button";
            this.WindowState = System.Windows.Forms.FormWindowState.Minimized;
            this.Load += new System.EventHandler(this.frmMain_Load);
            this.Closed += new System.EventHandler(this.frmMain_Closed);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.FrmMain_FormClosing);
            this.Resize += new System.EventHandler(this.FrmMain_Resize);
            this.contextMenuStrip1.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        private IntPtr deviceNotificationHandle;
        private Boolean exclusiveAccess;
        private SafeFileHandle hidHandle;
        private String hidUsage;
        private Boolean myDeviceDetected;
        private String myDevicePathName;
        private SafeFileHandle readHandle;
        private SafeFileHandle writeHandle;

        private Debugging MyDebugging = new Debugging(); //  For viewing results of API calls via Debug.Write.
        private DeviceManagement MyDeviceManagement = new DeviceManagement();
        private Hid MyHid = new Hid();

        internal FrmMain FrmMy;

        ///  <summary>
        ///  Define a class of delegates that point to the Hid.ReportIn.Read function.
        ///  The delegate has the same parameters as Hid.ReportIn.Read.
        ///  Used for asynchronous reads from the device.       
        ///  </summary>

        private delegate void ReadInputReportDelegate(SafeFileHandle hidHandle, SafeFileHandle readHandle, SafeFileHandle writeHandle, ref Boolean myDeviceDetected, ref Byte[] readBuffer, ref Boolean success);

        //  This delegate has the same parameters as AccessForm.
        //  Used in accessing the application's form from a different thread.

        private delegate void MarshalToForm(String action, String textToAdd);

        ///  <summary>
        ///  Called when a WM_DEVICECHANGE message has arrived,
        ///  indicating that a device has been attached or removed.
        ///  </summary>
        ///  
        ///  <param name="m"> a message with information about the device </param>

        internal void OnDeviceChange(Message m)
        {
            Debug.WriteLine("WM_DEVICECHANGE");

            try
            {
                if ((m.WParam.ToInt32() == DeviceManagement.DBT_DEVICEARRIVAL))
                {

                    //  If WParam contains DBT_DEVICEARRIVAL, a device has been attached.

                    Debug.WriteLine("A device has been attached.");

                    //  Find out if it's the device we're communicating with.

                    if (MyDeviceManagement.DeviceNameMatch(m, myDevicePathName))
                    {
                        //lstResults.Items.Add( "My device attached." ); 
                    }

                }
                else if ((m.WParam.ToInt32() == DeviceManagement.DBT_DEVICEREMOVECOMPLETE))
                {

                    //  If WParam contains DBT_DEVICEREMOVAL, a device has been removed.

                    Debug.WriteLine("A device has been removed.");

                    //  Find out if it's the device we're communicating with.

                    if (MyDeviceManagement.DeviceNameMatch(m, myDevicePathName))
                    {
                        //  Set MyDeviceDetected False so on the next data-transfer attempt,
                        //  FindTheHid() will be called to look for the device 
                        //  and get a new handle.

                        FrmMy.myDeviceDetected = false;
                    }
                }
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Uses a series of API calls to locate a HID-class device
        ///  by its Vendor ID and Product ID.
        ///  </summary>
        ///          
        ///  <returns>
        ///   True if the device is detected, False if not detected.
        ///  </returns>

        private Boolean FindTheHid()
        {
            Boolean deviceFound = false;
            String[] devicePathName = new String[128];
            String functionName = "";
            Guid hidGuid = Guid.Empty;
            Int32 memberIndex = 0;
            Int16 myProductID = 0;
            Int16 myVendorID = 0;
            Boolean success = false;

            try
            {
                myDeviceDetected = false;

                //  Get the device's Vendor ID and Product ID.

                GetVendorAndProductID(ref myVendorID, ref myProductID);

                //  ***
                //  API function: 'HidD_GetHidGuid

                //  Purpose: Retrieves the interface class GUID for the HID class.

                //  Accepts: 'A System.Guid object for storing the GUID.
                //  ***

                Hid.HidD_GetHidGuid(ref hidGuid);

                functionName = "GetHidGuid";
                Debug.WriteLine(MyDebugging.ResultOfAPICall(functionName));
                Debug.WriteLine("  GUID for system HIDs: " + hidGuid.ToString());

                //  Fill an array with the device path names of all attached HIDs.

                deviceFound = MyDeviceManagement.FindDeviceFromGuid(hidGuid, ref devicePathName);

                //  If there is at least one HID, attempt to read the Vendor ID and Product ID
                //  of each device until there is a match or all devices have been examined.

                if (deviceFound)
                {
                    memberIndex = 0;

                    do
                    {
                        //  ***
                        //  API function:
                        //  CreateFile

                        //  Purpose:
                        //  Retrieves a handle to a device.

                        //  Accepts:
                        //  A device path name returned by SetupDiGetDeviceInterfaceDetail
                        //  The type of access requested (read/write).
                        //  FILE_SHARE attributes to allow other processes to access the device while this handle is open.
                        //  A Security structure or Nothing. 
                        //  A creation disposition value. Use OPEN_EXISTING for devices.
                        //  Flags and attributes for files. Not used for devices.
                        //  Handle to a template file. Not used.

                        //  Returns: a handle without read or write access.
                        //  This enables obtaining information about all HIDs, even system
                        //  keyboards and mice. 
                        //  Separate handles are used for reading and writing.
                        //  ***

                        hidHandle = FileIO.CreateFile(devicePathName[memberIndex], 0, FileIO.FILE_SHARE_READ | FileIO.FILE_SHARE_WRITE, IntPtr.Zero, FileIO.OPEN_EXISTING, 0, 0);

                        functionName = "CreateFile";
                        Debug.WriteLine(MyDebugging.ResultOfAPICall(functionName));
                        Debug.WriteLine("  Returned handle: " + hidHandle.ToString());

                        if (!hidHandle.IsInvalid)
                        {
                            //  The returned handle is valid, 
                            //  so find out if this is the device we're looking for.

                            //  Set the Size property of DeviceAttributes to the number of bytes in the structure.

                            MyHid.DeviceAttributes.Size = Marshal.SizeOf(MyHid.DeviceAttributes);

                            //  ***
                            //  API function:
                            //  HidD_GetAttributes

                            //  Purpose:
                            //  Retrieves a HIDD_ATTRIBUTES structure containing the Vendor ID, 
                            //  Product ID, and Product Version Number for a device.

                            //  Accepts:
                            //  A handle returned by CreateFile.
                            //  A pointer to receive a HIDD_ATTRIBUTES structure.

                            //  Returns:
                            //  True on success, False on failure.
                            //  ***                            

                            success = Hid.HidD_GetAttributes(hidHandle, ref MyHid.DeviceAttributes);

                            if (success)
                            {
                                Debug.WriteLine("  HIDD_ATTRIBUTES structure filled without error.");
                                Debug.WriteLine("  Structure size: " + MyHid.DeviceAttributes.Size);
                                Debug.WriteLine("  Vendor ID: " + Convert.ToString(MyHid.DeviceAttributes.VendorID, 16));
                                Debug.WriteLine("  Product ID: " + Convert.ToString(MyHid.DeviceAttributes.ProductID, 16));
                                Debug.WriteLine("  Version Number: " + Convert.ToString(MyHid.DeviceAttributes.VersionNumber, 16));

                                //  Find out if the device matches the one we're looking for.

                                if ((MyHid.DeviceAttributes.VendorID == myVendorID) & (MyHid.DeviceAttributes.ProductID == myProductID))
                                {

                                    Debug.WriteLine("  My device detected");

                                    myDeviceDetected = true;

                                    //  Save the DevicePathName for OnDeviceChange().

                                    myDevicePathName = devicePathName[memberIndex];
                                }
                                else
                                {
                                    //  It's not a match, so close the handle.

                                    myDeviceDetected = false;
                                    hidHandle.Close();
                                }
                            }
                            else
                            {
                                //  There was a problem in retrieving the information.

                                Debug.WriteLine("  Error in filling HIDD_ATTRIBUTES structure.");
                                myDeviceDetected = false;
                                hidHandle.Close();
                            }
                        }

                        //  Keep looking until we find the device or there are no devices left to examine.

                        memberIndex = memberIndex + 1;
                    }
                    while (!((myDeviceDetected | (memberIndex == devicePathName.Length))));
                }

                if (myDeviceDetected)
                {
                    //  The device was detected.
                    //  Register to receive notifications if the device is removed or attached.

                    success = MyDeviceManagement.RegisterForDeviceNotifications(myDevicePathName, FrmMy.Handle, hidGuid, ref deviceNotificationHandle);

                    Debug.WriteLine("RegisterForDeviceNotifications = " + success);

                    //  Learn the capabilities of the device.

                    MyHid.Capabilities = MyHid.GetDeviceCapabilities(hidHandle);

                    if (success)
                    {
                        //  Find out if the device is a system mouse or keyboard.

                        hidUsage = MyHid.GetHidUsage(MyHid.Capabilities);

                        //  Get the Input report buffer size.

                        //GetInputReportBufferSize(); 
                        //cmdInputReportBufferSize.Enabled = true; 

                        //  Get handles to use in requesting Input and Output reports.

                        readHandle = FileIO.CreateFile(myDevicePathName, FileIO.GENERIC_READ, FileIO.FILE_SHARE_READ | FileIO.FILE_SHARE_WRITE, IntPtr.Zero, FileIO.OPEN_EXISTING, FileIO.FILE_FLAG_OVERLAPPED, 0);

                        functionName = "CreateFile, ReadHandle";
                        Debug.WriteLine(MyDebugging.ResultOfAPICall(functionName));
                        Debug.WriteLine("  Returned handle: " + readHandle.ToString());

                        if (readHandle.IsInvalid)
                        {
                            exclusiveAccess = true;

                        }
                        else
                        {
                            writeHandle = FileIO.CreateFile(myDevicePathName, FileIO.GENERIC_WRITE, FileIO.FILE_SHARE_READ | FileIO.FILE_SHARE_WRITE, IntPtr.Zero, FileIO.OPEN_EXISTING, 0, 0);

                            functionName = "CreateFile, WriteHandle";
                            Debug.WriteLine(MyDebugging.ResultOfAPICall(functionName));
                            Debug.WriteLine("  Returned handle: " + writeHandle.ToString());

                            //  Flush any waiting reports in the input buffer. (optional)

                            MyHid.FlushQueue(readHandle);
                        }
                    }
                }
                else
                {
                    //  The device wasn't detected.
                    Debug.WriteLine(" Device not found.");
                }
                return myDeviceDetected;
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  In asynchronous ReadFiles, the callback function GetInputReportData
        ///  uses this routine to access the application's form, which runs in 
        ///  a different thread.
        ///  The routine performs various application-specific functions that
        ///  involve accessing the application's form.
        ///  </summary>
        ///  
        ///  <param name="action"> a String that names the action to perform on the form</param>
        ///  <param name="formText"> text that the form displays or the code uses for 
        ///  another purpose. Actions that don't use text ignore this parameter. </param>

        private void AccessForm(String action, String formText)
        {
            try
            {
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Set the number of Input reports the host will store.
        ///  </summary>

        private void cmdInputReportBufferSize_Click(System.Object sender, System.EventArgs e)
        {
            try
            {
                SetInputReportBufferSize();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Called if the user changes the Vendor ID or Product ID in the text box.
        ///  </summary>

        private void DeviceHasChanged()
        {
            try
            {
                //  If a device was previously detected, stop receiving notifications about it.

                if (myDeviceDetected)
                {
                    MyDeviceManagement.StopReceivingDeviceNotifications(deviceNotificationHandle);
                }

                //  Search for the device the next time FindTheHid is called.

                myDeviceDetected = false;
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Sends a Feature report, then retrieves one.
        ///  Assumes report ID = 0 for both reports.
        ///  </summary>

        private void ExchangeFeatureReports()
        {
            String byteValue = null;
            Int32 count = 0;
            Byte[] inFeatureReportBuffer = null;
            Byte[] outFeatureReportBuffer = null;
            Boolean success = false;

            try
            {
                Hid.InFeatureReport myInFeatureReport = new Hid.InFeatureReport();
                Hid.OutFeatureReport myOutFeatureReport = new Hid.OutFeatureReport();

                inFeatureReportBuffer = null;

                if ((MyHid.Capabilities.FeatureReportByteLength > 0))
                {
                    //  The HID has a Feature report.

                    //  Set the size of the Feature report buffer. 
                    //  Subtract 1 from the value in the Capabilities structure because 
                    //  the array begins at index 0.

                    outFeatureReportBuffer = new Byte[MyHid.Capabilities.FeatureReportByteLength];

                    //  Store the report ID in the buffer:

                    outFeatureReportBuffer[0] = 0;

                    //  Store the report data following the report ID.
                    //  Use the data in the combo boxes on the form.

                    //outFeatureReportBuffer[ 1 ] = Convert.ToByte( cboByte0.SelectedIndex ); 

                    //if ( Information.UBound( outFeatureReportBuffer, 1 ) > 1 ) 
                    //{ 
                    //    outFeatureReportBuffer[ 2 ] = Convert.ToByte( cboByte1.SelectedIndex ); 
                    //}

                    //  Read a report from the device.

                    //  Set the size of the Feature report buffer. 
                    //  Subtract 1 from the value in the Capabilities structure because 
                    //  the array begins at index 0.

                    if ((MyHid.Capabilities.FeatureReportByteLength > 0))
                    {
                        inFeatureReportBuffer = new Byte[MyHid.Capabilities.FeatureReportByteLength];
                    }

                    //  Read a report.

                    myInFeatureReport.Read(hidHandle, readHandle, writeHandle, ref myDeviceDetected, ref inFeatureReportBuffer, ref success);

                    if (success)
                    {
                        if (Convert.ToInt32(inFeatureReportBuffer[1]) > 0)
                        {
                            DoAction();
                        }
                    }
                    else
                    {
                        Debug.Write("The attempt to read a Feature report failed.");
                    }
                }
                else
                {
                    Debug.Write("The HID doesn't have a Feature report.");
                }
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Perform shutdown operations.
        ///  </summary>

        private void frmMain_Closed(System.Object eventSender, System.EventArgs eventArgs)
        {
            try
            {
                Shutdown();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Perform startup operations.
        ///  </summary>

        private void frmMain_Load(System.Object eventSender, System.EventArgs eventArgs)
        {
            Hide();

            notifyIcon1.Visible = true;

            try
            {
                FrmMy = this;
                Startup();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Finds and displays the number of Input buffers
        ///  (the number of Input reports the host will store). 
        ///  </summary>

        private void GetInputReportBufferSize()
        {
            Int32 numberOfInputBuffers = 0;

            try
            {
                //  Get the number of input buffers.

                MyHid.GetNumberOfInputBuffers(hidHandle, ref numberOfInputBuffers);

                //  Display the result in the text box.

                //txtInputReportBufferSize.Text = Convert.ToString( numberOfInputBuffers );                 
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Retrieves a Vendor ID and Product ID in hexadecimal 
        ///  from the form's text boxes and converts the text to Int16s.
        ///  </summary>
        ///  
        ///  <param name="myVendorID"> the Vendor ID as a Int16.</param>
        ///  <param name="myProductID"> the Product ID as a Int16. </param>

        private void GetVendorAndProductID(ref Int16 myVendorID, ref Int16 myProductID)
        {
            try
            {
                myVendorID = Convert.ToInt16(Conversion.Val("&h1130"));
                myProductID = Convert.ToInt16(Conversion.Val("&h0202"));
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Initialize the elements on the form.
        ///  </summary>

        private void InitializeDisplay()
        {

        }

        ///  <summary>
        ///  Enables accessing a form's controls from another thread 
        ///  </summary>
        ///  
        ///  <param name="action"> a String that names the action to perform on the form </param>
        ///  <param name="textToDisplay"> text that the form displays or the code uses for 
        ///  another purpose. Actions that don't use text ignore this parameter.  </param>

        private void MyMarshalToForm(String action, String textToDisplay)
        {
            object[] args = { action, textToDisplay };
            MarshalToForm MarshalToFormDelegate = null;

            //  The AccessForm routine contains the code that accesses the form.

            MarshalToFormDelegate = new MarshalToForm(AccessForm);

            //  Execute AccessForm, passing the parameters in args.

            base.Invoke(MarshalToFormDelegate, args);
        }

        ///  <summary>
        ///  Initiates exchanging reports. 
        ///  The application sends a report and requests to read a report.
        ///  </summary>

        private void ReadAndWriteToDevice()
        {
            // Report header for the debug display:

            Debug.WriteLine("");
            Debug.WriteLine("***** HID Test Report *****");
            Debug.WriteLine(DateAndTime.Today + ": " + DateAndTime.TimeOfDay);

            try
            {
                //  If the device hasn't been detected, was removed, or timed out on a previous attempt
                //  to access it, look for the device.

                if ((myDeviceDetected == false))
                {
                    myDeviceDetected = FindTheHid();
                }

                if ((myDeviceDetected == true))
                {
                    ExchangeFeatureReports();
                }
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Set the number of Input buffers (the number of Input reports 
        ///  the host will store) from the value in the text box.
        ///  </summary>

        private void SetInputReportBufferSize()
        {
            Int32 numberOfInputBuffers = 0;

            try
            {
                MyHid.SetNumberOfInputBuffers(hidHandle, numberOfInputBuffers);
                GetInputReportBufferSize();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Perform actions that must execute when the program ends.
        ///  </summary>

        private void Shutdown()
        {
            try
            {
                SaveSettings();

                //  Close open handles to the device.

                if (!(hidHandle == null))
                {
                    if (!(hidHandle.IsInvalid))
                    {
                        hidHandle.Close();
                    }
                }

                if (!(readHandle == null))
                {
                    if (!(readHandle.IsInvalid))
                    {
                        readHandle.Close();
                    }
                }

                if (!(writeHandle == null))
                {
                    if (!(writeHandle.IsInvalid))
                    {
                        writeHandle.Close();
                    }
                }

                //  Stop receiving notifications.

                MyDeviceManagement.StopReceivingDeviceNotifications(deviceNotificationHandle);
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
            }
            finally
            {
                Application.Exit();
            }
        }

        ///  <summary>
        ///  Perform actions that must execute when the program starts.
        ///  </summary>

        private void Startup()
        {
            try
            {
                MyHid = new Hid();
                InitializeDisplay();
                tmrContinuousDataCollect.Enabled = false;
                tmrContinuousDataCollect.Interval = 10;
                FindTheHid();
                tmrContinuousDataCollect.Enabled = true;
                LoadSettings();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }

        }

        ///  <summary>
        ///  Exchange data with the device.
        ///  </summary>
        ///  
        ///  <remarks>
        ///  The timer is enabled only if cmdContinous has been clicked, 
        ///  selecting continous (periodic) transfers.
        ///  </remarks>

        private void tmrContinuousDataCollect_Tick(System.Object eventSender, System.EventArgs eventArgs)
        {
            try
            {
                ReadAndWriteToDevice();
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Finalize method.
        ///  </summary>

        ~FrmMain()
        {
        }

        ///  <summary>
        ///   Overrides WndProc to enable checking for and handling WM_DEVICECHANGE messages.
        ///  </summary>
        ///  
        ///  <param name="m"> a Windows Message </param>

        protected override void WndProc(ref Message m)
        {
            try
            {
                //  The OnDeviceChange routine processes WM_DEVICECHANGE messages.

                if (m.Msg == DeviceManagement.WM_DEVICECHANGE)
                {
                    OnDeviceChange(m);
                }

                //  Let the base form process the message.

                base.WndProc(ref m);
            }
            catch (Exception ex)
            {
                DisplayException(this.Name, ex);
                throw;
            }
        }

        ///  <summary>
        ///  Provides a central mechanism for exception handling.
        ///  Displays a message box that describes the exception.
        ///  </summary>
        ///  
        ///  <param name="moduleName"> the module where the exception occurred. </param>
        ///  <param name="e"> the exception </param>

        private static void DisplayException(String moduleName, Exception e)
        {
            String message = null;
            String caption = null;

            //  Create an error message.
            message = "Exception: " + e.Message + ControlChars.CrLf + "Module: " + moduleName + ControlChars.CrLf + "Method: " + e.TargetSite.Name;
            Debug.Write(message);
        }

        [STAThread]
        public static void Main()
        {
            Process aProcess = Process.GetCurrentProcess();
            string aProcName = aProcess.ProcessName;

            if (Process.GetProcessesByName(aProcName).Length > 1)
            {
                Application.ExitThread();
            }
            else
            {
                Application.Run(new FrmMain());
            }
        }

        private static FrmMain transDefaultFormFrmMain = null;
        public static FrmMain TransDefaultFormFrmMain
        {
            get
            {
                if (transDefaultFormFrmMain == null)
                {
                    transDefaultFormFrmMain = new FrmMain();
                }
                return transDefaultFormFrmMain;
            }
        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }

        private void FrmMain_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == this.WindowState)
                Hide();
        }

        private void cmdWav_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Wav files (*.wav) | *.wav";
            fd.ShowDialog();
            if (!string.IsNullOrEmpty(fd.FileName))
                txtWav.Text = fd.FileName;
        }

        private void cmdCommand_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.ShowDialog();
            if (!string.IsNullOrEmpty(fd.FileName))
                txtCommand.Text = fd.FileName;
        }

        private void DoAction()
        {
            if (Actions.frmPicture == null)
            {
                if (!string.IsNullOrEmpty(txtWav.Text.Trim())) Actions.PlaySound(txtWav.Text);

                if (!string.IsNullOrEmpty(txtPicture.Text.Trim())) Actions.ShowPicture(txtPicture.Text, chkEarthQuake.Checked);

                if (Actions.frmPicture == null && chkEarthQuake.Checked) Actions.EarthQuake();

                if (chkPowerPoint.Checked) Actions.PowerPointNextSlide();

                if (!string.IsNullOrEmpty(txtCommand.Text.Trim())) Actions.DoCommand(txtCommand.Text);
            }
            else
            {
                Actions.frmPicture.Dispose();
                Actions.frmPicture = null;
            }

            SaveSettings();
        }

        private void LoadSettings()
        {
           Properties.Settings settings = new Properties.Settings();
           settings.Reload();
           chkEarthQuake.Checked = settings.EarthQuake;
           chkPowerPoint.Checked = settings.PowerPoint;
           txtCommand.Text = settings.Command;
           txtWav.Text = settings.SoundFile;
           txtPicture.Text = settings.Picture;
        }

        private void SaveSettings()
        {
            Properties.Settings settings = new Properties.Settings();
            settings.EarthQuake = chkEarthQuake.Checked;
            settings.PowerPoint = chkPowerPoint.Checked;
            settings.Command = txtCommand.Text;
            settings.SoundFile = txtWav.Text;
            settings.Picture = txtPicture.Text;
            settings.Save();
        }

        private void cmdPicture_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Image files (*.gif, *.jpg, *.jpeg, *.png) | *.gif;*.jpg;*.jpeg;*.png";
            fd.ShowDialog();
            if (!string.IsNullOrEmpty(fd.FileName))
                txtPicture.Text = fd.FileName;
        }

        private void Settings_Click(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }

        private void Exit_Click(object sender, EventArgs e)
        {
            Shutdown();
        }

        private void FrmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (this.WindowState != FormWindowState.Minimized)
            {
                this.WindowState = FormWindowState.Minimized;
                Hide();
                e.Cancel = true;
            }
        }

        private void cmdPictureClear_Click(object sender, EventArgs e)
        {
            txtPicture.Text = "";
        }

        private void cmdSoundClear_Click(object sender, EventArgs e)
        {
            txtWav.Text = "";
        }

        private void cmdCommandClear_Click(object sender, EventArgs e)
        {
            txtCommand.Text = "";
        }

        private void cmdTest_Click(object sender, EventArgs e)
        {
            DoAction();
        }
    }
}
